unit Pad;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Menus, ComCtrls, ToolWin, ImgList;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    FontDialog1: TFontDialog;
    ReplaceDialog1: TReplaceDialog;
    FindDialog1: TFindDialog;
    MainMenu1: TMainMenu;
    mnuEdit: TMenuItem;
    mnuFile: TMenuItem;
    mnuSearch: TMenuItem;
    mnuHelp: TMenuItem;
    mnuOpen: TMenuItem;
    mnuSave: TMenuItem;
    mnuSaveAs: TMenuItem;
    N8: TMenuItem;
    mnuExit: TMenuItem;
    mnuFont: TMenuItem;
    mnuAbout: TMenuItem;
    mnuFind: TMenuItem;
    mnuReplacement: TMenuItem;
    ImageList1: TImageList;
    ToolBar1: TToolBar;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    StatusBar1: TStatusBar;
    ToolButton1: TToolButton;
    ToolButton6: TToolButton;
    ToolButton8: TToolButton;
    ToolButton9: TToolButton;
    ToolButton7: TToolButton;
    mnuCopy: TMenuItem;
    mnuPast: TMenuItem;
    ToolButton10: TToolButton;
    ToolButton11: TToolButton;
    ToolButton12: TToolButton;
    ToolButton13: TToolButton;
    mnuCut: TMenuItem;
    N2: TMenuItem;
    ToolButton14: TToolButton;
    ToolButton15: TToolButton;
    ToolButton16: TToolButton;
    ToolButton17: TToolButton;
    ToolButton18: TToolButton;
    mnuInsert: TMenuItem;
    N1: TMenuItem;
    mnuSelectAll: TMenuItem;
    N3: TMenuItem;
    mnu: TMenuItem;
    mnuClear: TMenuItem;
    Timer1: TTimer;
    mnuKind: TMenuItem;
    mnuStatusBar: TMenuItem;
    mnuToolBar: TMenuItem;





    procedure FontDialog1Apply(Sender: TObject; Wnd: HWND);


    procedure FindDialog1Find(Sender: TObject);
    procedure ReplaceDialog1Replace(Sender: TObject);
    procedure mnuOpenClick(Sender: TObject);
    procedure mnuSaveClick(Sender: TObject);
    procedure mnuSaveAsClick(Sender: TObject);
    procedure mnuExitClick(Sender: TObject);
    procedure mnuFontClick(Sender: TObject);
    procedure mnuFindClick(Sender: TObject);
    procedure mnuReplacementClick(Sender: TObject);
    procedure mnuAboutClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure mnuCopyClick(Sender: TObject);
    procedure mnuPastClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure ToolButton14Click(Sender: TObject);
    procedure ToolButton15Click(Sender: TObject);
    procedure ToolButton16Click(Sender: TObject);
    procedure ToolButton18Click(Sender: TObject);
    procedure N1Click(Sender: TObject);
    procedure mnuCutClick(Sender: TObject);
    procedure mnuClearClick(Sender: TObject);
    procedure mnuSelectAllClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure mnuStatusBarClick(Sender: TObject);
    procedure mnuToolBarClick(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

{   }
procedure TForm1.FontDialog1Apply(Sender: TObject; Wnd: HWND);
begin
     Memo1.Font:= FontDialog1.Font;
end;
{  }
procedure TForm1.FindDialog1Find(Sender: TObject);
var
   Buff, P, FT: PChar;
   BuffLen: Word;
begin
     With Sender As TFindDialog Do
     begin
      GetMem(FT, Length(FindText) + 1);
      StrPCopy(FT, FindText);
      BuffLen:= Memo1.GetTextLen + 1;
      GetMem(Buff, BuffLen);
      Memo1.GetTextBuf(Buff, BuffLen);
      P:= Buff + Memo1.SelStart + Memo1.SelLength;
      P:= StrPos(P, FT);
      If P = Nil Then MessageBeep(0)
      else
      begin
       Memo1.SelStart:= P - Buff;
       Memo1.SelLength:= Length(FindText);
      end;
      FreeMem(FT, Length(FindText) + 1);
      FreeMem(Buff, BuffLen);
     end;
end;

procedure TForm1.ReplaceDialog1Replace(Sender: TObject);
begin
     With Sender As TReplaceDialog Do
      While True Do
       begin
        If Memo1.SelText <> FindText Then
        FindDialog1Find(Sender);
        If Memo1.SelLength = 0 Then Break;
        Memo1.SelText:= ReplaceText;
        If Not (frReplaceAll In Options) Then Break;
       end;
end;


{   }
procedure TForm1.mnuOpenClick(Sender: TObject);
begin

With OpenDialog1 Do
      If Execute Then
       begin
        Memo1.Lines.LoadFromFile(FileName);
        HistoryList.Add(FileName);
        Caption:= '  - '+
        ExtractFileName(FileName);
        SaveDialog1.Filename:= FileName;
        FileName:= '';
        mnuSave.Enabled := True; //   
        ToolButton3.Enabled :=True; //  
       end;

end;
{  }
procedure TForm1.mnuSaveClick(Sender: TObject);
begin
Memo1.Lines.SaveToFile(SaveDialog1.FileName);
end;
{   }
procedure TForm1.mnuSaveAsClick(Sender: TObject);
begin
With SaveDialog1 Do
      If Execute Then
       begin
        Memo1.Lines.SaveToFile(FileName);
        Caption:= '  - ' +
        ExtractFileName(FileName);
        mnuSave.Enabled := True;
        ToolButton3.Enabled := True;
       end;
end;
{ }
procedure TForm1.mnuExitClick(Sender: TObject);
begin
Close;
end;

procedure TForm1.mnuFontClick(Sender: TObject);
begin
With FontDialog1 Do
      If Execute Then
      Memo1.Font:= Font;
end;

procedure TForm1.mnuFindClick(Sender: TObject);
begin
FindDialog1.Execute;
end;

procedure TForm1.mnuReplacementClick(Sender: TObject);
begin
  ReplaceDialog1.Execute;
end;

{   }
procedure TForm1.mnuAboutClick(Sender: TObject);
begin
Application.MessageBox(' '+#13#10+'Copyright (c) 2001  Alex-Co',
' ', MB_ICONINFORMATION);
end;



procedure TForm1.FormCreate(Sender: TObject);
begin
{   }
LoadKeyboardLayout('00000419', KLF_ACTIVATE);

end;

procedure TForm1.mnuCopyClick(Sender: TObject);
begin
If ActiveControl is TMemo then TMemo(ActiveControl).CopyToClipboard;
end;

procedure TForm1.mnuPastClick(Sender: TObject);
begin
If ActiveControl is TMemo then TMemo(ActiveControl).PasteFromClipboard;
end;

//     
procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
var
  SaveResp: Integer;
begin
if not memo1.Modified then Exit;
 SaveResp := Application.MessageBox('   ',' ',
 MB_ICONEXCLAMATION + MB_YESNOCANCEL);
  case SaveResp of
    idYes: mnuSaveAs.Click;
    idNo: ;
    idCancel: Abort; //    
  end;
end;

procedure TForm1.ToolButton14Click(Sender: TObject);
begin
Memo1.Alignment:= taCenter;
end;

procedure TForm1.ToolButton15Click(Sender: TObject);
begin
Memo1.Alignment:= taLeftJustify;
end;

procedure TForm1.ToolButton16Click(Sender: TObject);
begin
Memo1.Alignment:= taRightJustify;
end;

{ }
procedure TForm1.ToolButton18Click(Sender: TObject);
begin
 with Memo1 do
    if HandleAllocated then SendMessage(Handle, EM_UNDO, 0, 0);
end;

//    /  memo-
procedure TForm1.N1Click(Sender: TObject);
Var
s : string ;

begin
s :=  DateToStr( Date ) + ' ' + TimeToStr( Time ) + '  :' ;
Memo1.Lines.Insert( 0,  s ) ;
Memo1.SetFocus ;
Memo1.SelStart := Length( s ) ;
Memo1.SelLength := 0 ;

end;

//  
procedure TForm1.mnuCutClick(Sender: TObject);
begin
Memo1.ClearSelection;
end;

//  
procedure TForm1.mnuClearClick(Sender: TObject);
begin
Memo1.Clear;
end;

// 
procedure TForm1.mnuSelectAllClick(Sender: TObject);
begin
Memo1.SelectAll;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var
CurrentLine : Integer;
ColNum : Integer;
begin
//     
CurrentLine :=SendMessage(Memo1.Handle,EM_LINEFROMCHAR,Memo1.SelStart, 0);
StatusBar1.Panels[0].Text := ': ' + IntToStr(CurrentLine);

//     
ColNum := Memo1.SelStart-SendMessage(Memo1.Handle,EM_LINEINDEX,CurrentLine, 0) + 1;
StatusBar1.Panels[1].Text := ': '+ IntToStr(ColNum);

end;

procedure TForm1.mnuStatusBarClick(Sender: TObject);
begin
If  mnuStatusBar.Checked = False then begin
StatusBar1.Visible := True;
mnuStatusBar.Checked := True;
end
else begin // else    ;  .
StatusBar1.Visible := False;
mnuStatusBar.Checked := False;
end;

end;

procedure TForm1.mnuToolBarClick(Sender: TObject);
begin
If  mnuToolBar.Checked = False then begin
ToolBar1.Visible := True;
mnuToolBar.Checked := True;
end
else begin // else    ;  .
ToolBar1.Visible := False;
mnuToolBar.Checked := False;
end;
end;

end.


